#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

#include <string>

namespace Prekl {

	/// <summary>
	/// Summary for MainForm
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class MainForm : public System::Windows::Forms::Form
	{
	public:
		static MainForm ^ win;

	public:
		MainForm(void)
		{
			win = this;
			InitializeComponent ();
			Read ("data/Test.inp");
		}

	protected:
		~MainForm()
		{
			if (components)
			{
				delete components;
			}
		}

	public:
		std::string GetInpLine (int line_num);
		std::string GetInpText ();

		void ClearOutLines ();
		void ShowOutLine (std::string txt);

        void ShowError (std::string txt);

        void SetStatus (String ^ txt);
		void Read (String ^ file_name);
		void Compile ();

	private: System::Windows::Forms::MenuStrip^  mainMenu;
	private: System::Windows::Forms::StatusStrip^  statusBar;
	private: System::Windows::Forms::SplitContainer^  splitter;
	private: System::Windows::Forms::TextBox^  inputArea;
	private: System::Windows::Forms::ToolStripMenuItem^  fileMenu;
	private: System::Windows::Forms::ToolStripMenuItem^  runMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  quitMenuItem;
	private: System::Windows::Forms::TextBox^  outputArea;
	private: System::Windows::Forms::ToolStripStatusLabel^  statusLabel;
	private: System::Windows::Forms::ToolStripMenuItem^  openMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  saveMenuItem;
	private: System::Windows::Forms::OpenFileDialog^  openFileDialog;
	private: System::Windows::Forms::SaveFileDialog^  saveFileDialog;
	private: System::Windows::Forms::ToolStripMenuItem^  editMenu;
	private: System::Windows::Forms::ToolStripMenuItem^  cutMenuItem;

	private: System::Windows::Forms::ToolStripMenuItem^  copyMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  pasteMenuItem;

	private: System::Windows::Forms::ToolStripMenuItem^  fontMenuItem;
	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator1;
	private: System::Windows::Forms::FontDialog^  fontDialog;




	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->mainMenu = (gcnew System::Windows::Forms::MenuStrip());
			this->fileMenu = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->openMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->saveMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->runMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->quitMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->editMenu = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->fontMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator1 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->cutMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->copyMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->pasteMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->statusBar = (gcnew System::Windows::Forms::StatusStrip());
			this->statusLabel = (gcnew System::Windows::Forms::ToolStripStatusLabel());
			this->splitter = (gcnew System::Windows::Forms::SplitContainer());
			this->inputArea = (gcnew System::Windows::Forms::TextBox());
			this->outputArea = (gcnew System::Windows::Forms::TextBox());
			this->openFileDialog = (gcnew System::Windows::Forms::OpenFileDialog());
			this->saveFileDialog = (gcnew System::Windows::Forms::SaveFileDialog());
			this->fontDialog = (gcnew System::Windows::Forms::FontDialog());
			this->mainMenu->SuspendLayout();
			this->statusBar->SuspendLayout();
			this->splitter->Panel1->SuspendLayout();
			this->splitter->Panel2->SuspendLayout();
			this->splitter->SuspendLayout();
			this->SuspendLayout();
			// 
			// mainMenu
			// 
			this->mainMenu->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->fileMenu, this->editMenu});
			this->mainMenu->Location = System::Drawing::Point(0, 0);
			this->mainMenu->Name = L"mainMenu";
			this->mainMenu->Size = System::Drawing::Size(657, 24);
			this->mainMenu->TabIndex = 0;
			this->mainMenu->Text = L"menuStrip1";
			// 
			// fileMenu
			// 
			this->fileMenu->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(4) {this->openMenuItem, 
				this->saveMenuItem, this->runMenuItem, this->quitMenuItem});
			this->fileMenu->Name = L"fileMenu";
			this->fileMenu->Size = System::Drawing::Size(35, 20);
			this->fileMenu->Text = L"&File";
			// 
			// openMenuItem
			// 
			this->openMenuItem->Name = L"openMenuItem";
			this->openMenuItem->ShortcutKeys = static_cast<System::Windows::Forms::Keys>((System::Windows::Forms::Keys::Control | System::Windows::Forms::Keys::O));
			this->openMenuItem->Size = System::Drawing::Size(151, 22);
			this->openMenuItem->Text = L"&Open";
			this->openMenuItem->Click += gcnew System::EventHandler(this, &MainForm::openMenuItem_Click);
			// 
			// saveMenuItem
			// 
			this->saveMenuItem->Name = L"saveMenuItem";
			this->saveMenuItem->ShortcutKeys = static_cast<System::Windows::Forms::Keys>((System::Windows::Forms::Keys::Control | System::Windows::Forms::Keys::S));
			this->saveMenuItem->Size = System::Drawing::Size(151, 22);
			this->saveMenuItem->Text = L"&Save";
			this->saveMenuItem->Click += gcnew System::EventHandler(this, &MainForm::saveMenuItem_Click);
			// 
			// runMenuItem
			// 
			this->runMenuItem->Name = L"runMenuItem";
			this->runMenuItem->ShortcutKeys = static_cast<System::Windows::Forms::Keys>((System::Windows::Forms::Keys::Control | System::Windows::Forms::Keys::R));
			this->runMenuItem->Size = System::Drawing::Size(151, 22);
			this->runMenuItem->Text = L"&Run";
			this->runMenuItem->Click += gcnew System::EventHandler(this, &MainForm::runMenuItem_Click);
			// 
			// quitMenuItem
			// 
			this->quitMenuItem->Name = L"quitMenuItem";
			this->quitMenuItem->ShortcutKeys = static_cast<System::Windows::Forms::Keys>((System::Windows::Forms::Keys::Control | System::Windows::Forms::Keys::Q));
			this->quitMenuItem->Size = System::Drawing::Size(151, 22);
			this->quitMenuItem->Text = L"&Quit";
			this->quitMenuItem->Click += gcnew System::EventHandler(this, &MainForm::quitMenuItem_Click);
			// 
			// editMenu
			// 
			this->editMenu->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(5) {this->fontMenuItem, 
				this->toolStripSeparator1, this->cutMenuItem, this->copyMenuItem, this->pasteMenuItem});
			this->editMenu->Name = L"editMenu";
			this->editMenu->Size = System::Drawing::Size(37, 20);
			this->editMenu->Text = L"Edit";
			// 
			// fontMenuItem
			// 
			this->fontMenuItem->Name = L"fontMenuItem";
			this->fontMenuItem->ShortcutKeys = static_cast<System::Windows::Forms::Keys>((System::Windows::Forms::Keys::Control | System::Windows::Forms::Keys::F));
			this->fontMenuItem->Size = System::Drawing::Size(145, 22);
			this->fontMenuItem->Text = L"&Font";
			this->fontMenuItem->Click += gcnew System::EventHandler(this, &MainForm::fontMenuItem_Click);
			// 
			// toolStripSeparator1
			// 
			this->toolStripSeparator1->Name = L"toolStripSeparator1";
			this->toolStripSeparator1->Size = System::Drawing::Size(142, 6);
			// 
			// cutMenuItem
			// 
			this->cutMenuItem->Name = L"cutMenuItem";
			this->cutMenuItem->Size = System::Drawing::Size(145, 22);
			this->cutMenuItem->Text = L"Cut";
			this->cutMenuItem->Click += gcnew System::EventHandler(this, &MainForm::cutMenuItem_Click);
			// 
			// copyMenuItem
			// 
			this->copyMenuItem->Name = L"copyMenuItem";
			this->copyMenuItem->Size = System::Drawing::Size(145, 22);
			this->copyMenuItem->Text = L"Copy";
			this->copyMenuItem->Click += gcnew System::EventHandler(this, &MainForm::copyMenuItem_Click);
			// 
			// pasteMenuItem
			// 
			this->pasteMenuItem->Name = L"pasteMenuItem";
			this->pasteMenuItem->Size = System::Drawing::Size(145, 22);
			this->pasteMenuItem->Text = L"Paste";
			this->pasteMenuItem->Click += gcnew System::EventHandler(this, &MainForm::pasteMenuItem_Click);
			// 
			// statusBar
			// 
			this->statusBar->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->statusLabel});
			this->statusBar->Location = System::Drawing::Point(0, 408);
			this->statusBar->Name = L"statusBar";
			this->statusBar->Size = System::Drawing::Size(657, 22);
			this->statusBar->TabIndex = 1;
			this->statusBar->Text = L"statusStrip1";
			// 
			// statusLabel
			// 
			this->statusLabel->Name = L"statusLabel";
			this->statusLabel->Size = System::Drawing::Size(0, 17);
			// 
			// splitter
			// 
			this->splitter->Dock = System::Windows::Forms::DockStyle::Fill;
			this->splitter->Location = System::Drawing::Point(0, 24);
			this->splitter->Name = L"splitter";
			this->splitter->Orientation = System::Windows::Forms::Orientation::Horizontal;
			// 
			// splitter.Panel1
			// 
			this->splitter->Panel1->Controls->Add(this->inputArea);
			// 
			// splitter.Panel2
			// 
			this->splitter->Panel2->Controls->Add(this->outputArea);
			this->splitter->Size = System::Drawing::Size(657, 384);
			this->splitter->SplitterDistance = 190;
			this->splitter->TabIndex = 2;
			// 
			// inputArea
			// 
			this->inputArea->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->inputArea->Location = System::Drawing::Point(0, 0);
			this->inputArea->Multiline = true;
			this->inputArea->Name = L"inputArea";
			this->inputArea->Size = System::Drawing::Size(657, 187);
			this->inputArea->TabIndex = 0;
			// 
			// outputArea
			// 
			this->outputArea->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->outputArea->Location = System::Drawing::Point(0, 3);
			this->outputArea->Multiline = true;
			this->outputArea->Name = L"outputArea";
			this->outputArea->Size = System::Drawing::Size(654, 187);
			this->outputArea->TabIndex = 0;
			// 
			// openFileDialog
			// 
			this->openFileDialog->FileName = L"openFileDialog1";
			// 
			// MainForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(657, 430);
			this->Controls->Add(this->splitter);
			this->Controls->Add(this->statusBar);
			this->Controls->Add(this->mainMenu);
			this->MainMenuStrip = this->mainMenu;
			this->Name = L"MainForm";
			this->Text = L"02 Stat";
			this->mainMenu->ResumeLayout(false);
			this->mainMenu->PerformLayout();
			this->statusBar->ResumeLayout(false);
			this->statusBar->PerformLayout();
			this->splitter->Panel1->ResumeLayout(false);
			this->splitter->Panel1->PerformLayout();
			this->splitter->Panel2->ResumeLayout(false);
			this->splitter->Panel2->PerformLayout();
			this->splitter->ResumeLayout(false);
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	private: 
	    System::Void openMenuItem_Click(System::Object^  sender, System::EventArgs^  e);
        System::Void saveMenuItem_Click(System::Object^  sender, System::EventArgs^  e);

		System::Void runMenuItem_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			Compile ();
		}

		System::Void quitMenuItem_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			Close ();
  		}

    private: 
	   System::Void fontMenuItem_Click(System::Object^  sender, System::EventArgs^  e);

	   System::Void cutMenuItem_Click(System::Object^  sender, System::EventArgs^  e) 
	   {
			 inputArea->Cut ();
	   }

	   System::Void copyMenuItem_Click(System::Object^  sender, System::EventArgs^  e) 
	   {
	  	    inputArea->Copy ();
	   }

   	   System::Void pasteMenuItem_Click(System::Object^  sender, System::EventArgs^  e) 
	   {
			inputArea->Paste ();
	   }
   };

} // end of namespace

// global function
Prekl::MainForm ^ getMainForm ();
