
/* STAT.C */

#include "stdafx.h"

#include <string.h>
// #include <alloc.h>

#include "Stat0.h"

/******************************* EXPRESSION *******************************/

void SimpleExpr (void)
{
   if (sy != IDENT &&
       sy != NUM &&
       sy != FLT &&
       sy != STR &&
       sy != CHR) Error ("Expression expected");

   NextSymbol ();
}

void expression (void)
{
   SimpleExpr ();

   if (sy == ASSIGN)
   {
      NextSymbol ();
      SimpleExpr ();
   }
}

/********************************** INFO **********************************/

void info (char * txt)
{
   /* informace o jednoduchem prikazu */
   PutStr (txt);
   PutEol ();
}

void open_info (char * txt)
{
   /* informace o vnorenych prikazech */
   PutStr (txt);
   PutEol ();
   Indent ();
}

void close_info (void)
{
   Unindent ();
}

/******************************* STATEMENTS *******************************/

void statement (void)
{
  if (sy==GOTO_)                               /* goto */
  {
     NextSymbol ();
     CheckSymbol (IDENT);
     CheckSymbol (SEMICOLON);

     info ("goto");
  }

  else if (sy==CONTINUE_)                      /* continue */
  {
     NextSymbol ();
     CheckSymbol (SEMICOLON);

     info ("continue");
  }

  else if (sy==BREAK_)                         /* break */
  {
     NextSymbol ();
     CheckSymbol (SEMICOLON);

     info ("break");
  }

  else if (sy==RETURN_)                        /* return */
  {
     NextSymbol ();
     if (sy!=SEMICOLON) expression ();
     CheckSymbol (SEMICOLON);
     info ("return");
  }

  else if (sy==WHILE_)                         /* while */
  {
     NextSymbol ();
     CheckSymbol (LPAR);
     expression ();
     CheckSymbol (RPAR);

     open_info ("while");
     statement ();
     close_info ();
  }

  else if (sy==DO_)                            /* do */
  {
     NextSymbol ();

     open_info ("do");
     statement ();
     close_info ();

     CheckSymbol (WHILE_);
     CheckSymbol (LPAR);
     expression ();
     CheckSymbol (RPAR);
     CheckSymbol (SEMICOLON);
  }

  else if (sy==FOR_)                           /* for */
  {
     NextSymbol ();
     CheckSymbol (LPAR);

     if (sy!=SEMICOLON) expression ();
     CheckSymbol (SEMICOLON);

     if (sy!=SEMICOLON) expression ();
     CheckSymbol (SEMICOLON);

     if (sy!=RPAR) expression ();
     CheckSymbol (RPAR);


     open_info ("for");
     statement ();
     close_info ();
  }

  else if (sy==IF_)                            /* if */
  {
     NextSymbol ();
     CheckSymbol (LPAR);
     expression ();
     CheckSymbol (RPAR);

     open_info ("if");
     statement ();
     close_info ();

     if (sy==ELSE_)
     {
        NextSymbol ();
        open_info ("else");
        statement ();
        close_info ();
     }
  }

  else if (sy==SWITCH_)                        /* switch */
  {
     NextSymbol ();
     CheckSymbol (LPAR);
     expression ();
     CheckSymbol (RPAR);

     open_info ("switch");
     statement ();
     close_info ();
  }

  else if (sy==LBRACE)                         /* { } */
  {
     NextSymbol ();
     open_info ("compound statement");

     while (sy!=RBRACE)
        statement ();

     close_info ();
     NextSymbol ();
  }

  else if (sy==CASE_)                          /* case */
  {
     NextSymbol ();
     expression ();
     CheckSymbol (COLON);

     info ("case");
  }

  else if (sy==DEFAULT_)                       /* default */
  {
     NextSymbol ();
     CheckSymbol (COLON);

     info ("default");
  }

  else                                         /* label, expression, empty statement */
  {
     if (sy != SEMICOLON)
     {
        expression ();

        if (sy==COLON)
           statement ();
     }

     info ("simple statement");
     CheckSymbol (SEMICOLON);
  }
}


